Clp 1.17.6

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Groups Pages
Public Member Functions | Static Private Attributes | Friends | List of all members
OsiMskSolverInterface Class Reference

`#include <OsiMskSolverInterface.hpp>`

Inheritance diagram for OsiMskSolverInterface:
[legend]
Collaboration diagram for OsiMskSolverInterface:
[legend]

## Public Member Functions
virtual void | setObjSense (double s)
| Set objective function sense (1 for min (default), -1 for max,) More...
virtual void | setColSolution (const double *colsol)
| Set the primal solution column values. More...
virtual void | setRowPrice (const double *rowprice)
| Set dual solution vector. More...
const char * | getCtype () const
| return a vector of variable types (continous, binary, integer) More...
Solve methods
virtual void | initialSolve ()
| Solve initial LP relaxation. More...
virtual void | resolve ()
| Resolve an LP relaxation after problem modification. More...
virtual void | branchAndBound ()
| Invoke solver's built-in enumeration algorithm. More...
Parameter set/get methods
The set methods return true if the parameter was set to the given value, false otherwise. There can be various reasons for failure: the given parameter is not applicable for the solver (e.g., refactorization frequency for the volume algorithm), the parameter is not yet implemented for the solver or simply the value of the parameter is out of the range the solver accepts. If a parameter setting call returns false check the details of your solver. The get methods return true if the given parameter is applicable for the solver and is implemented. In this case the value of the parameter is returned in the second argument. Otherwise they return false.
bool | setIntParam (OsiIntParam key, int value)
| Set an integer parameter. More...
bool | setDblParam (OsiDblParam key, double value)
| Set a double parameter. More...
bool | setStrParam (OsiStrParam key, const std::string &value)
| Set a string parameter. More...
bool | getIntParam (OsiIntParam key, int &value) const
| Get an integer parameter. More...
bool | getDblParam (OsiDblParam key, double &value) const
| Get a double parameter. More...
bool | getStrParam (OsiStrParam key, std::string &value) const
| Get a string parameter. More...
Methods returning info on how the solution process terminated
virtual bool | isAbandoned () const
| Are there a numerical difficulties? More...
virtual bool | isProvenOptimal () const
| Is optimality proven? More...
virtual bool | isProvenPrimalInfeasible () const
| Is primal infeasiblity proven? More...
virtual bool | isProvenDualInfeasible () const
| Is dual infeasiblity proven? More...
virtual bool | isPrimalObjectiveLimitReached () const
| Is the given primal objective limit reached? More...
virtual bool | isDualObjectiveLimitReached () const
| Is the given dual objective limit reached? More...
virtual bool | isIterationLimitReached () const
| Iteration limit reached? More...
virtual bool | isLicenseError () const
| Has there been a license problem? More...
int | getRescode () const
| Get rescode return of last Mosek optimizer call. More...
WarmStart related methods
CoinWarmStart * | getEmptyWarmStart () const
| Get an empty warm start object. More...
virtual CoinWarmStart * | getWarmStart () const
| Get warmstarting information. More...
virtual bool | setWarmStart (const CoinWarmStart *warmstart)
| Set warmstarting information. More...
Hotstart related methods (primarily used in strong branching). <br>
The user can create a hotstart (a snapshot) of the optimization process then reoptimize over and over again always starting from there. NOTE: between hotstarted optimizations only bound changes are allowed.
virtual void | markHotStart ()
| Create a hotstart point of the optimization process. More...
virtual void | solveFromHotStart ()
| Optimize starting from the hotstart. More...
virtual void | unmarkHotStart ()
| Delete the snapshot. More...
Methods related to querying the input data
virtual int | getNumCols () const
| Get number of columns. More...
virtual int | getNumRows () const
| Get number of rows. More...
virtual int | getNumElements () const
| Get number of nonzero elements. More...
virtual const double * | getColLower () const
| Get pointer to array[getNumCols()] of column lower bounds. More...
virtual const double * | getColUpper () const
| Get pointer to array[getNumCols()] of column upper bounds. More...
virtual const char * | getRowSense () const
| Get pointer to array[getNumRows()] of row constraint senses. More...
virtual const double * | getRightHandSide () const
| Get pointer to array[getNumRows()] of rows right-hand sides. More...
virtual const double * | getRowRange () const
| Get pointer to array[getNumRows()] of row ranges. More...
virtual const double * | getRowLower () const
| Get pointer to array[getNumRows()] of row lower bounds. More...
virtual const double * | getRowUpper () const
| Get pointer to array[getNumRows()] of row upper bounds. More...
virtual const double * | getObjCoefficients () const
| Get pointer to array[getNumCols()] of objective function coefficients. More...
virtual double | getObjSense () const
| Get objective function sense (1 for min (default), -1 for max) More...
virtual bool | isContinuous (int colNumber) const
| Return true if column is continuous. More...
virtual const CoinPackedMatrix * | getMatrixByRow () const
| Get pointer to row-wise copy of matrix. More...
virtual const CoinPackedMatrix * | getMatrixByCol () const
| Get pointer to column-wise copy of matrix. More...
virtual double | getInfinity () const
| Get solver's value for infinity. More...
Methods related to querying the solution
virtual const double * | getColSolution () const
| Get pointer to array[getNumCols()] of primal solution vector. More...
virtual const double * | getRowPrice () const
| Get pointer to array[getNumRows()] of dual prices. More...
virtual const double * | getReducedCost () const
| Get a pointer to array[getNumCols()] of reduced costs. More...
virtual const double * | getRowActivity () const
| Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector. More...
virtual double | getObjValue () const
| Get objective function value. More...
virtual int | getIterationCount () const
| Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver. More...
virtual std::vector< double * > | getDualRays (int maxNumRays, bool fullRay=false) const
| Get as many dual rays as the solver can provide. More...
virtual std::vector< double * > | getPrimalRays (int maxNumRays) const
| Get as many primal rays as the solver can provide. More...
Changing bounds on variables and constraints
virtual void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient. More...
virtual void | setObjCoeffSet (const int *indexFirst, const int *indexLast, const double *coeffList)
| Set a a set of objective function coefficients. More...
virtual void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -COIN_DBL_MAX for -infinity. More...
virtual void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use COIN_DBL_MAX for infinity. More...
virtual void | setColBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound The default implementation just invokes `setColLower()` and `setColUpper()` More...
virtual void | setColSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously The default implementation just invokes `setCollower()` and `setColupper()` over and over again. More...
virtual void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound Use -COIN_DBL_MAX for -infinity. More...
virtual void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound Use COIN_DBL_MAX for infinity. More...
virtual void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound The default implementation just invokes `setRowLower()` and `setRowUpper()` More...
virtual void | setRowType (int index, char sense, double rightHandSide, double range)
| Set the type of a single row More...
virtual void | setRowSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of rows simultaneously The default implementation just invokes `setRowLower()` and `setRowUpper()` over and over again. More...
virtual void | setRowSetTypes (const int *indexFirst, const int *indexLast, const char *senseList, const double *rhsList, const double *rangeList)
| Set the type of a number of rows simultaneously The default implementation just invokes `setRowType()` and over and over again. More...
Integrality related changing methods
virtual void | setContinuous (int index)
| Set the index-th variable to be a continuous variable. More...
virtual void | setInteger (int index)
| Set the index-th variable to be an integer variable. More...
virtual void | setContinuous (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be continuous variables. More...
virtual void | setInteger (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be integer variables. More...
Methods to expand a problem.<br>
Note that if a column is added then by default it will correspond to a continuous variable.
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj)
| Add a column (primal variable) to the problem. More...
virtual void | addCols (const int numcols, const CoinPackedVectorBase *const *cols, const double *collb, const double *colub, const double *obj)
| Add a set of columns (primal variables) to the problem. More...
virtual void | deleteCols (const int num, const int *colIndices)
| Remove a set of columns (primal variables) from the problem. More...
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub)
| Add a row (constraint) to the problem. More...
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng)
| Add a row (constraint) to the problem. More...
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const double *rowlb, const double *rowub)
| Add a set of rows (constraints) to the problem. More...
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const char *rowsen, const double *rowrhs, const double *rowrng)
| Add a set of rows (constraints) to the problem. More...
virtual void | deleteRows (const int num, const int *rowIndices)
| Delete a set of rows (constraints) from the problem. More...
Methods to input a problem
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds). More...
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, double *&rowlb, double *&rowub)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds). More...
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets). More...
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, char *&rowsen, double *&rowrhs, double *&rowrng)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets). More...
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps). More...
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps). More...
virtual int | readMps (const char *filename, const char *extension="mps")
| Read an mps file from the given filename. More...
virtual void | writeMps (const char *filename, const char *extension="mps", double objSense=0.0) const
| Write the problem into an mps file of the given filename. More...
Message handling
void | passInMessageHandler (CoinMessageHandler *handler)
| Pass in a message handler It is the client's responsibility to destroy a message handler installed by this routine; it will not be destroyed when the solver interface is destroyed. More...
Constructors and destructor
| OsiMskSolverInterface (MSKenv_t mskenv=NULL)
| Default Constructor optional argument mskenv can be used to reach in an initialized user environment OsiMsk assumes membership of mskenv, so it will be freed when the last instanciation of OsiMsk is deleted. More...
virtual OsiSolverInterface * | clone (bool copyData=true) const
| Clone. More...
| OsiMskSolverInterface (const OsiMskSolverInterface &)
| Copy constructor. More...
OsiMskSolverInterface & | operator= (const OsiMskSolverInterface &rhs)
| Assignment operator. More...
virtual | ~OsiMskSolverInterface ()
| Destructor. More...
Public Member Functions inherited from OsiSolverInterface
virtual bool | setHintParam (OsiHintParam key, bool yesNo=true, OsiHintStrength strength=OsiHintTry, void *=NULL)
| Set a hint parameter. More...
virtual bool | getHintParam (OsiHintParam key, bool &yesNo, OsiHintStrength &strength, void *&otherInformation) const
| Get a hint parameter (all information) More...
virtual bool | getHintParam (OsiHintParam key, bool &yesNo, OsiHintStrength &strength) const
| Get a hint parameter (sense and strength only) More...
virtual bool | getHintParam (OsiHintParam key, bool &yesNo) const
| Get a hint parameter (sense only) More...
void | copyParameters (OsiSolverInterface &rhs)
| Copy all parameters in this section from one solver to another. More...
double | getIntegerTolerance () const
| Return the integrality tolerance of the underlying solver. More...
virtual CoinWarmStart * | getPointerToWarmStart (bool &mustDelete)
| Get warm start information. More...
virtual int | getNumIntegers () const
| Get the number of integer variables. More...
virtual bool | isBinary (int colIndex) const
| Return true if the variable is binary. More...
virtual bool | isInteger (int colIndex) const
| Return true if the variable is integer. More...
virtual bool | isIntegerNonBinary (int colIndex) const
| Return true if the variable is general integer. More...
virtual bool | isFreeBinary (int colIndex) const
| Return true if the variable is binary and not fixed. More...
const char * | columnType (bool refresh=false) const
| Return an array[getNumCols()] of column types. More...
void | setColumnType (int iColumn, char type)
| Set column type. More...
virtual const char * | getColType (bool refresh=false) const
| Return an array[getNumCols()] of column types. More...
virtual CoinPackedMatrix * | getMutableMatrixByRow () const
| Get a pointer to a mutable row-wise copy of the matrix. More...
virtual CoinPackedMatrix * | getMutableMatrixByCol () const
| Get a pointer to a mutable column-wise copy of the matrix. More...
virtual const double * | getStrictColSolution ()
| Get a pointer to an array[getNumCols()] of primal variable values guaranteed to be between the column lower and upper bounds. More...
virtual OsiVectorInt | getFractionalIndices (const double etol=1.e-05) const
| Get vector of indices of primal variables which are integer variables but have fractional values in the current solution. More...
virtual void | setObjective (const double *array)
| Set the objective coefficients for all columns. More...
virtual void | setColLower (const double *array)
| Set the lower bounds for all columns. More...
virtual void | setColUpper (const double *array)
| Set the upper bounds for all columns. More...
virtual int | reducedCostFix (double gap, bool justInteger=true)
| Fix variables at bound based on reduced cost. More...
virtual std::string | dfltRowColName (char rc, int ndx, unsigned digits=7) const
| Generate a standard name of the form Rnnnnnnn or Cnnnnnnn. More...
virtual std::string | getObjName (unsigned maxLen=static_cast< unsigned >(std::string::npos)) const
| Return the name of the objective function. More...
virtual void | setObjName (std::string name)
| Set the name of the objective function. More...
virtual std::string | getRowName (int rowIndex, unsigned maxLen=static_cast< unsigned >(std::string::npos)) const
| Return the name of the row. More...
virtual const OsiNameVec & | getRowNames ()
| Return a pointer to a vector of row names. More...
virtual void | setRowName (int ndx, std::string name)
| Set a row name. More...
virtual void | setRowNames (OsiNameVec &srcNames, int srcStart, int len, int tgtStart)
| Set multiple row names. More...
virtual void | deleteRowNames (int tgtStart, int len)
| Delete len row names starting at index tgtStart. More...
virtual std::string | getColName (int colIndex, unsigned maxLen=static_cast< unsigned >(std::string::npos)) const
| Return the name of the column. More...
virtual const OsiNameVec & | getColNames ()
| Return a pointer to a vector of column names. More...
virtual void | setColName (int ndx, std::string name)
| Set a column name. More...
virtual void | setColNames (OsiNameVec &srcNames, int srcStart, int len, int tgtStart)
| Set multiple column names. More...
virtual void | deleteColNames (int tgtStart, int len)
| Delete len column names starting at index tgtStart. More...
void | setRowColNames (const CoinMpsIO &mps)
| Set row and column names from a CoinMpsIO object. More...
void | setRowColNames (CoinModel &mod)
| Set row and column names from a CoinModel object. More...
void | setRowColNames (CoinLpIO &mod)
| Set row and column names from a CoinLpIO object. More...
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj, std::string name)
| Add a named column (primal variable) to the problem. More...
virtual void | addCol (int numberElements, const int *rows, const double *elements, const double collb, const double colub, const double obj)
| Add a column (primal variable) to the problem. More...
virtual void | addCol (int numberElements, const int *rows, const double *elements, const double collb, const double colub, const double obj, std::string name)
| Add a named column (primal variable) to the problem. More...
virtual void | addCols (const int numcols, const CoinBigIndex *columnStarts, const int *rows, const double *elements, const double *collb, const double *colub, const double *obj)
| Add a set of columns (primal variables) to the problem. More...
void | addCols (const CoinBuild &buildObject)
| Add columns using a CoinBuild object. More...
int | addCols (CoinModel &modelObject)
| Add columns from a model object. More...
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub, std::string name)
| Add a named row (constraint) to the problem. More...
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng, std::string name)
| Add a named row (constraint) to the problem. More...
virtual void | addRow (int numberElements, const int *columns, const double *element, const double rowlb, const double rowub)
| Add a row (constraint) to the problem. More...
virtual void | addRows (const int numrows, const CoinBigIndex *rowStarts, const int *columns, const double *element, const double *rowlb, const double *rowub)
| Add a set of rows (constraints) to the problem. More...
void | addRows (const CoinBuild &buildObject)
| Add rows using a CoinBuild object. More...
int | addRows (CoinModel &modelObject)
| Add rows from a CoinModel object. More...
virtual void | replaceMatrixOptional (const CoinPackedMatrix &)
| Replace the constraint matrix. More...
virtual void | replaceMatrix (const CoinPackedMatrix &)
| Replace the constraint matrix. More...
virtual void | saveBaseModel ()
| Save a copy of the base model. More...
virtual void | restoreBaseModel (int numberRows)
| Reduce the constraint system to the specified number of constraints. More...
virtual ApplyCutsReturnCode | applyCuts (const OsiCuts &cs, double effectivenessLb=0.0)
| Apply a collection of cuts. More...
virtual void | applyRowCuts (int numberCuts, const OsiRowCut *cuts)
| Apply a collection of row cuts which are all effective. More...
virtual void | applyRowCuts (int numberCuts, const OsiRowCut **cuts)
| Apply a collection of row cuts which are all effective. More...
void | deleteBranchingInfo (int numberDeleted, const int *which)
| Deletes branching information before columns deleted. More...
virtual int | loadFromCoinModel (CoinModel &modelObject, bool keepSolution=false)
| Load a model from a CoinModel object. More...
virtual int | readMps (const char *filename, const char *extension, int &numberSets, CoinSet **&sets)
| Read a problem in MPS format from the given full filename. More...
virtual int | readGMPL (const char *filename, const char *dataname=NULL)
| Read a problem in GMPL format from the given filenames. More...
int | writeMpsNative (const char *filename, const char **rowNames, const char **columnNames, int formatType=0, int numberAcross=2, double objSense=0.0, int numberSOS=0, const CoinSet *setInfo=NULL) const
| Write the problem in MPS format to the specified file with more control over the output. More...
virtual void | writeLp (const char *filename, const char *extension="lp", double epsilon=1e-5, int numberAcross=10, int decimals=9, double objSense=0.0, bool useRowNames=true) const
| Write the problem into an Lp file of the given filename with the specified extension. More...
virtual void | writeLp (FILE *fp, double epsilon=1e-5, int numberAcross=10, int decimals=5, double objSense=0.0, bool useRowNames=true) const
| Write the problem into the file pointed to by the parameter fp. More...
int | writeLpNative (const char *filename, char const *const *const rowNames, char const *const *const columnNames, const double epsilon=1.0e-5, const int numberAcross=10, const int decimals=5, const double objSense=0.0, const bool useRowNames=true) const
| Write the problem into an Lp file. More...
int | writeLpNative (FILE *fp, char const *const *const rowNames, char const *const *const columnNames, const double epsilon=1.0e-5, const int numberAcross=10, const int decimals=5, const double objSense=0.0, const bool useRowNames=true) const
| Write the problem into the file pointed to by the parameter fp. More...
virtual int | readLp (const char *filename, const double epsilon=1e-5)
| Read file in LP format from file with name filename. More...
int | readLp (FILE *fp, const double epsilon=1e-5)
| Read file in LP format from the file pointed to by fp. More...
int | differentModel (OsiSolverInterface &other, bool ignoreNames=true)
| Check two models against each other. More...
void | statistics (double &minimumNegative, double &maximumNegative, double &minimumPositive, double &maximumPositive, int type=3) const
| Get some statistics about model - min/max always computed type 0->4 , larger gives more information 0 - Just set min and max values of coefficients. More...
void | setApplicationData (void *appData)
| Set application data. More...
void | setAuxiliaryInfo (OsiAuxInfo *auxiliaryInfo)
| Create a clone of an Auxiliary Information object. More...
void * | getApplicationData () const
| Get application data. More...
OsiAuxInfo * | getAuxiliaryInfo () const
| Get pointer to auxiliary info object. More...
void | newLanguage (CoinMessages::Language language)
| Set language. More...
void | setLanguage (CoinMessages::Language language)
CoinMessageHandler * | messageHandler () const
| Return a pointer to the current message handler. More...
CoinMessages | messages ()
| Return the current set of messages. More...
CoinMessages * | messagesPointer ()
| Return a pointer to the current set of messages. More...
bool | defaultHandler () const
| Return true if default handler. More...
void | findIntegers (bool justCount)
| Identify integer variables and create corresponding objects. More...
virtual int | findIntegersAndSOS (bool justCount)
| Identify integer variables and SOS and create corresponding objects. More...
int | numberObjects () const
| Get the number of objects. More...
void | setNumberObjects (int number)
| Set the number of objects. More...
OsiObject ** | objects () const
| Get the array of objects. More...
const OsiObject * | object (int which) const
| Get the specified object. More...
OsiObject * | modifiableObject (int which) const
| Get the specified object. More...
void | deleteObjects ()
| Delete all object information. More...
void | addObjects (int numberObjects, OsiObject **objects)
| Add in object information. More...
double | forceFeasible ()
| Use current solution to set bounds so current integer feasible solution will stay feasible. More...
virtual void | activateRowCutDebugger (const char *modelName)
| Activate the row cut debugger. More...
virtual void | activateRowCutDebugger (const double *solution, bool enforceOptimality=true)
| Activate the row cut debugger using a full solution array. More...
const OsiRowCutDebugger * | getRowCutDebugger () const
| Get the row cut debugger provided the solution known to the debugger is within the feasible region held in the solver. More...
OsiRowCutDebugger * | getRowCutDebuggerAlways () const
| Get the row cut debugger object. More...
virtual int | canDoSimplexInterface () const
| Return the simplex implementation level. More...
virtual void | enableFactorization () const
| Prepare the solver for the use of tableau access methods. More...
virtual void | disableFactorization () const
| Undo the effects of enableFactorization. More...
virtual bool | basisIsAvailable () const
| Check if an optimal basis is available. More...
bool | optimalBasisIsAvailable () const
| Synonym for basisIsAvailable. More...
virtual void | getBasisStatus (int *cstat, int *rstat) const
| Retrieve status information for column and row variables. More...
virtual int | setBasisStatus (const int *cstat, const int *rstat)
| Set the status of column and row variables and update the basis factorization and solution. More...
virtual void | getReducedGradient (double *columnReducedCosts, double *duals, const double *c) const
| Calculate duals and reduced costs for the given objective coefficients. More...
virtual void | getBInvARow (int row, double *z, double *slack=NULL) const
| Get a row of the tableau. More...
virtual void | getBInvRow (int row, double *z) const
| Get a row of the basis inverse. More...
virtual void | getBInvACol (int col, double *vec) const
| Get a column of the tableau. More...
virtual void | getBInvCol (int col, double *vec) const
| Get a column of the basis inverse. More...
virtual void | getBasics (int *index) const
| Get indices of basic variables. More...
virtual void | enableSimplexInterface (bool doingPrimal)
| Enables normal operation of subsequent functions. More...
virtual void | disableSimplexInterface ()
| Undo whatever setting changes the above method had to make. More...
virtual int | pivot (int colIn, int colOut, int outStatus)
| Perform a pivot by substituting a colIn for colOut in the basis. More...
virtual int | primalPivotResult (int colIn, int sign, int &colOut, int &outStatus, double &t, CoinPackedVector *dx)
| Obtain a result of the primal pivot Outputs: colOut – leaving column, outStatus – its status, t – step size, and, if dx!=NULL, *dx – primal ray direction. More...
virtual int | dualPivotResult (int &colIn, int &sign, int colOut, int outStatus, double &t, CoinPackedVector *dx)
| Obtain a result of the dual pivot (similar to the previous method) Differences: entering variable and a sign of its change are now the outputs, the leaving variable and its statuts – the inputs If dx!=NULL, then *dx contains dual ray Return code: same. More...
| OsiSolverInterface ()
| Default Constructor. More...
| OsiSolverInterface (const OsiSolverInterface &)
| Copy constructor. More...
OsiSolverInterface & | operator= (const OsiSolverInterface &rhs)
| Assignment operator. More...
virtual | ~OsiSolverInterface ()
| Destructor. More...
virtual void | reset ()
| Reset the solver interface. More...

## Static Public Member Functions
Static instance counter methods
static void | incrementInstanceCounter ()
| MOSEK has a context which must be created prior to all other MOSEK calls. More...
static void | decrementInstanceCounter ()
| MOSEK has a context which should be deleted after MOSEK calls. More...
static unsigned int | getNumInstances ()
| Return the number of instances of instantiated objects using MOSEK services. More...

## Public Attributes
Private member data
MSKtask_t | task_
| MOSEK model represented by this class instance. More...
int * | hotStartCStat_
| Hotstart information. More...
int | hotStartCStatSize_
int * | hotStartRStat_
int | hotStartRStatSize_
int | hotStartMaxIteration_
Cached information derived from the MOSEK model
double * | obj_
| Pointer to objective vector. More...
double * | collower_
| Pointer to dense vector of variable lower bounds. More...
double * | colupper_
| Pointer to dense vector of variable lower bounds. More...
char * | rowsense_
| Pointer to dense vector of row sense indicators. More...
double * | rhs_
| Pointer to dense vector of row right-hand side values. More...
double * | rowrange_
| Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows) More...
double * | rowlower_
| Pointer to dense vector of row lower bounds. More...
double * | rowupper_
| Pointer to dense vector of row upper bounds. More...
double * | colsol_
| Pointer to primal solution vector. More...
double * | rowsol_
| Pointer to dual solution vector. More...
double * | redcost_
| Pointer to reduced cost vector. More...
double * | rowact_
| Pointer to row activity (slack) vector. More...
CoinPackedMatrix * | matrixByRow_
| Pointer to row-wise copy of problem matrix coefficients. More...
CoinPackedMatrix * | matrixByCol_
| Pointer to row-wise copy of problem matrix coefficients. More...
Additional information needed for storing MIP problems
char * | coltype_
| Pointer to dense vector of variable types (continous, binary, integer) More...
int | coltypesize_
| Size of allocated memory for coltype_. More...
bool | probtypemip_
| Stores whether MOSEK' prob type is currently set to MIP. More...

## Protected Member Functions
Protected methods
virtual void | applyRowCut (const OsiRowCut &rc)
| Apply a row cut. Return true if cut was applied. More...
virtual void | applyColCut (const OsiColCut &cc)
| Apply a column cut (bound adjustment). More...
Protected Member Functions inherited from OsiSolverInterface
void | convertBoundToSense (const double lower, const double upper, char &sense, double &right, double &range) const
| A quick inlined function to convert from the lb/ub style of constraint definition to the sense/rhs/range style. More...
void | convertSenseToBound (const char sense, const double right, const double range, double &lower, double &upper) const
| A quick inlined function to convert from the sense/rhs/range style of constraint definition to the lb/ub style. More...
template<class T >
T | forceIntoRange (const T value, const T lower, const T upper) const
| A quick inlined function to force a value to be between a minimum and a maximum value. More...
void | setInitialData ()
| Set OsiSolverInterface object state for default constructor. More...

## Private Member Functions
Private static class functions
void | switchToLP ()
| switches MOSEK to prob type LP More...
void | switchToMIP ()
| switches MOSEK to prob type MIP More...
void | resizeColType (int minsize)
| resizes coltype_ vector to be able to store at least minsize elements More...
void | freeColType ()
| frees colsize_ vector More...
bool | definedSolution (int solution) const
int | solverUsed () const

## Static Private Attributes
static unsigned int | numInstances_
| Number of live problem instances. More...
Private static class data
static MSKenv_t | env_
| MOSEK environment pointer. More...

## Friends
void | OsiMskSolverInterfaceUnitTest (const std::string &mpsDir, const std::string &netlibDir)
| A function that tests the methods in the OsiMskSolverInterface class. More...

## MOSEK specific public interfaces
enum | keepCachedFlag { KEEPCACHED_NONE = 0, KEEPCACHED_COLUMN = 1, KEEPCACHED_ROW = 2, KEEPCACHED_MATRIX = 4, KEEPCACHED_RESULTS = 8, KEEPCACHED_PROBLEM = KEEPCACHED_COLUMN | KEEPCACHED_ROW | KEEPCACHED_MATRIX, KEEPCACHED_ALL = KEEPCACHED_PROBLEM | KEEPCACHED_RESULTS, FREECACHED_COLUMN = KEEPCACHED_PROBLEM & ~KEEPCACHED_COLUMN, FREECACHED_ROW = KEEPCACHED_PROBLEM & ~KEEPCACHED_ROW, FREECACHED_MATRIX = KEEPCACHED_PROBLEM & ~KEEPCACHED_MATRIX, FREECACHED_RESULTS = KEEPCACHED_ALL & ~KEEPCACHED_RESULTS }
| Get pointer to MOSEK model and free all specified cached data entries (combined with logical or-operator '|' ): More...
MSKtask_t | getLpPtr (int keepCached=KEEPCACHED_NONE)
MSKenv_t | getEnvironmentPtr ()
| Method to access MOSEK environment pointer. More...

## Private methods
int | Mskerr
int | MSKsolverused_
double | ObjOffset_
int | InitialSolver
MSKtask_t | getMutableLpPtr () const
| Get task Pointer for const methods. More...
void | gutsOfCopy (const OsiMskSolverInterface &source)
| The real work of a copy constructor (used by copy and assignment) More...
void | gutsOfConstructor ()
| The real work of the constructor. More...
void | gutsOfDestructor ()
| The real work of the destructor. More...
void | freeCachedColRim ()
| free cached column rim vectors More...
void | freeCachedRowRim ()
| free cached row rim vectors More...
void | freeCachedResults ()
| free cached result vectors More...
void | freeCachedMatrix ()
| free cached matrices More...
void | freeCachedData (int keepCached=KEEPCACHED_NONE)
| free all cached data (except specified entries, see getLpPtr()) More...
void | freeAllMemory ()
| free all allocated memory More...

## Additional Inherited Members
Public Types inherited from OsiSolverInterface
typedef std::vector< std::string > | OsiNameVec
| Data type for name vectors. More...
Protected Attributes inherited from OsiSolverInterface
OsiRowCutDebugger * | rowCutDebugger_
| Pointer to row cut debugger object. More...
CoinMessageHandler * | handler_
| Message handler. More...
bool | defaultHandler_
| Flag to say if the currrent handler is the default handler. More...
CoinMessages | messages_
| Messages. More...
int | numberIntegers_
| Number of integers. More...
int | numberObjects_
| Total number of objects. More...
OsiObject ** | object_
| Integer and ... information (integer info normally at beginning) More...
char * | columnType_
| Column type 0 - continuous 1 - binary (may get fixed later) 2 - general integer (may get fixed later) 3 - if supported - semi-continuous 4 - if supported - semi-continuous integer. More...

## Detailed Description

Definition at line 23 of file OsiMskSolverInterface.hpp.

## Member Enumeration Documentation

enum OsiMskSolverInterface::keepCachedFlag

Get pointer to MOSEK model and free all specified cached data entries (combined with logical or-operator '|' ):

Enumerator
KEEPCACHED_NONE | discard all cached data (default)
KEEPCACHED_COLUMN | column information: objective values, lower and upper bounds, variable types
KEEPCACHED_ROW | row information: right hand sides, ranges and senses, lower and upper bounds for row
KEEPCACHED_MATRIX | problem matrix: matrix ordered by column and by row
KEEPCACHED_RESULTS | LP solution: primal and dual solution, reduced costs, row activities.
KEEPCACHED_PROBLEM | only discard cached LP solution
KEEPCACHED_ALL | keep all cached data (similar to getMutableLpPtr())
FREECACHED_COLUMN | free only cached column and LP solution information
FREECACHED_ROW | free only cached row and LP solution information
FREECACHED_MATRIX | free only cached matrix and LP solution information
FREECACHED_RESULTS | free only cached LP solution information

Definition at line 598 of file OsiMskSolverInterface.hpp.

## Constructor & Destructor Documentation

OsiMskSolverInterface::OsiMskSolverInterface | ( | MSKenv_t | mskenv = `NULL` | ) |

Default Constructor optional argument mskenv can be used to reach in an initialized user environment OsiMsk assumes membership of mskenv, so it will be freed when the last instanciation of OsiMsk is deleted.

OsiMskSolverInterface::OsiMskSolverInterface | ( | const OsiMskSolverInterface & |  | ) |

Copy constructor.

virtual OsiMskSolverInterface::~OsiMskSolverInterface | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

virtual void OsiMskSolverInterface::initialSolve | ( |  | ) |
| virtual

Solve initial LP relaxation.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::resolve | ( |  | ) |
| virtual

Resolve an LP relaxation after problem modification.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::branchAndBound | ( |  | ) |
| virtual

Invoke solver's built-in enumeration algorithm.

Implements OsiSolverInterface.

bool OsiMskSolverInterface::setIntParam | ( | OsiIntParam | key,
|  | int | value
| ) |  |
| virtual

Set an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiMskSolverInterface::setDblParam | ( | OsiDblParam | key,
|  | double | value
| ) |  |
| virtual

Set a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiMskSolverInterface::setStrParam | ( | OsiStrParam | key,
|  | const std::string & | value
| ) |  |
| virtual

Set a string parameter.

Reimplemented from OsiSolverInterface.

bool OsiMskSolverInterface::getIntParam | ( | OsiIntParam | key,
|  | int & | value
| ) |  | const
| virtual

Get an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiMskSolverInterface::getDblParam | ( | OsiDblParam | key,
|  | double & | value
| ) |  | const
| virtual

Get a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiMskSolverInterface::getStrParam | ( | OsiStrParam | key,
|  | std::string & | value
| ) |  | const
| virtual

Get a string parameter.

Reimplemented from OsiSolverInterface.

virtual bool OsiMskSolverInterface::isAbandoned | ( |  | ) | const
| virtual

Are there a numerical difficulties?

Implements OsiSolverInterface.

virtual bool OsiMskSolverInterface::isProvenOptimal | ( |  | ) | const
| virtual

Is optimality proven?

Implements OsiSolverInterface.

virtual bool OsiMskSolverInterface::isProvenPrimalInfeasible | ( |  | ) | const
| virtual

Is primal infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiMskSolverInterface::isProvenDualInfeasible | ( |  | ) | const
| virtual

Is dual infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiMskSolverInterface::isPrimalObjectiveLimitReached | ( |  | ) | const
| virtual

Is the given primal objective limit reached?

Reimplemented from OsiSolverInterface.

virtual bool OsiMskSolverInterface::isDualObjectiveLimitReached | ( |  | ) | const
| virtual

Is the given dual objective limit reached?

Reimplemented from OsiSolverInterface.

virtual bool OsiMskSolverInterface::isIterationLimitReached | ( |  | ) | const
| virtual

Iteration limit reached?

Implements OsiSolverInterface.

virtual bool OsiMskSolverInterface::isLicenseError | ( |  | ) | const
| virtual

Has there been a license problem?

int OsiMskSolverInterface::getRescode | ( |  | ) | const
| inline

Get rescode return of last Mosek optimizer call.

Definition at line 91 of file OsiMskSolverInterface.hpp.

CoinWarmStart* OsiMskSolverInterface::getEmptyWarmStart | ( |  | ) | const
| virtual

Get an empty warm start object.

This routine returns an empty CoinWarmStartBasis object. Its purpose is to provide a way to give a client a warm start basis object of the appropriate type, which can resized and modified as desired.

Implements OsiSolverInterface.

virtual CoinWarmStart* OsiMskSolverInterface::getWarmStart | ( |  | ) | const
| virtual

Get warmstarting information.

Implements OsiSolverInterface.

virtual bool OsiMskSolverInterface::setWarmStart | ( | const CoinWarmStart * | warmstart | ) |
| virtual

Set warmstarting information.

Return true/false depending on whether the warmstart information was accepted or not.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::markHotStart | ( |  | ) |
| virtual

Create a hotstart point of the optimization process.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::solveFromHotStart | ( |  | ) |
| virtual

Optimize starting from the hotstart.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::unmarkHotStart | ( |  | ) |
| virtual

Delete the snapshot.

Reimplemented from OsiSolverInterface.

virtual int OsiMskSolverInterface::getNumCols | ( |  | ) | const
| virtual

Get number of columns.

Implements OsiSolverInterface.

virtual int OsiMskSolverInterface::getNumRows | ( |  | ) | const
| virtual

Get number of rows.

Implements OsiSolverInterface.

virtual int OsiMskSolverInterface::getNumElements | ( |  | ) | const
| virtual

Get number of nonzero elements.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getColLower | ( |  | ) | const
| virtual

Get pointer to array[getNumCols()] of column lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getColUpper | ( |  | ) | const
| virtual

Get pointer to array[getNumCols()] of column upper bounds.

Implements OsiSolverInterface.

virtual const char* OsiMskSolverInterface::getRowSense | ( |  | ) | const
| virtual

Get pointer to array[getNumRows()] of row constraint senses.

- 'L': <= constraint
- 'E': = constraint
- 'G': >= constraint
- 'R': ranged constraint
- 'N': free constraint

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getRightHandSide | ( |  | ) | const
| virtual

Get pointer to array[getNumRows()] of rows right-hand sides.

- if rowsense()[i] == 'L' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'G' then rhs()[i] == rowlower()[i]
- if rowsense()[i] == 'R' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'N' then rhs()[i] == 0.0

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getRowRange | ( |  | ) | const
| virtual

Get pointer to array[getNumRows()] of row ranges.

- if rowsense()[i] == 'R' then rowrange()[i] == rowupper()[i] - rowlower()[i]
- if rowsense()[i] != 'R' then rowrange()[i] is 0.0

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getRowLower | ( |  | ) | const
| virtual

Get pointer to array[getNumRows()] of row lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getRowUpper | ( |  | ) | const
| virtual

Get pointer to array[getNumRows()] of row upper bounds.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getObjCoefficients | ( |  | ) | const
| virtual

Get pointer to array[getNumCols()] of objective function coefficients.

Implements OsiSolverInterface.

virtual double OsiMskSolverInterface::getObjSense | ( |  | ) | const
| virtual

Get objective function sense (1 for min (default), -1 for max)

Implements OsiSolverInterface.

virtual bool OsiMskSolverInterface::isContinuous | ( | int | colNumber | ) | const
| virtual

Return true if column is continuous.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiMskSolverInterface::getMatrixByRow | ( |  | ) | const
| virtual

Get pointer to row-wise copy of matrix.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiMskSolverInterface::getMatrixByCol | ( |  | ) | const
| virtual

Get pointer to column-wise copy of matrix.

Implements OsiSolverInterface.

virtual double OsiMskSolverInterface::getInfinity | ( |  | ) | const
| virtual

Get solver's value for infinity.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getColSolution | ( |  | ) | const
| virtual

Get pointer to array[getNumCols()] of primal solution vector.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getRowPrice | ( |  | ) | const
| virtual

Get pointer to array[getNumRows()] of dual prices.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getReducedCost | ( |  | ) | const
| virtual

Get a pointer to array[getNumCols()] of reduced costs.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getRowActivity | ( |  | ) | const
| virtual

Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.

Implements OsiSolverInterface.

virtual double OsiMskSolverInterface::getObjValue | ( |  | ) | const
| virtual

Get objective function value.

Implements OsiSolverInterface.

virtual int OsiMskSolverInterface::getIterationCount | ( |  | ) | const
| virtual

Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.

Implements OsiSolverInterface.

virtual std::vector<double*> OsiMskSolverInterface::getDualRays | ( | int | maxNumRays,
|  | bool | fullRay = `false`
| ) |  | const
| virtual

Get as many dual rays as the solver can provide.

(In case of proven primal infeasibility there should be at least one.)

The first getNumRows() ray components will always be associated with the row duals (as returned by getRowPrice()). If `fullRay` is true, the final getNumCols() entries will correspond to the ray components associated with the nonbasic variables. If the full ray is requested and the method cannot provide it, it will throw an exception.

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumRows() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual std::vector<double*> OsiMskSolverInterface::getPrimalRays | ( | int | maxNumRays | ) | const
| virtual

Get as many primal rays as the solver can provide.

(In case of proven dual infeasibility there should be at least one.)

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumCols() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue
| ) |  |
| virtual

Set an objective function coefficient.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setObjCoeffSet | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | coeffList
| ) |  |
| virtual

Set a a set of objective function coefficients.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setColLower | ( | int | elementIndex,
|  | double | elementValue
| ) |  |
| virtual

Set a single column lower bound
Use -COIN_DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setColUpper | ( | int | elementIndex,
|  | double | elementValue
| ) |  |
| virtual

Set a single column upper bound
Use COIN_DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setColBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper
| ) |  |
| virtual

Set a single column lower and upper bound
The default implementation just invokes `setColLower()` and `setColUpper()`

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setColSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList
| ) |  |
| virtual

Set the bounds on a number of columns simultaneously
The default implementation just invokes `setCollower()` and `setColupper()` over and over again.

Parameters

  <code>[indexfirst,indexLast]</code> | contains the indices of the constraints whose either bound changes
  boundList | the new lower/upper bound pairs for the variables

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setRowLower | ( | int | elementIndex,
|  | double | elementValue
| ) |  |
| virtual

Set a single row lower bound
Use -COIN_DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setRowUpper | ( | int | elementIndex,
|  | double | elementValue
| ) |  |
| virtual

Set a single row upper bound
Use COIN_DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setRowBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper
| ) |  |
| virtual

Set a single row lower and upper bound
The default implementation just invokes `setRowLower()` and `setRowUpper()`

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setRowType | ( | int | index,
|  | char | sense,
|  | double | rightHandSide,
|  | double | range
| ) |  |
| virtual

Set the type of a single row

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setRowSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList
| ) |  |
| virtual

Set the bounds on a number of rows simultaneously
The default implementation just invokes `setRowLower()` and `setRowUpper()` over and over again.

Parameters

  <code>[indexfirst,indexLast]</code> | contains the indices of the constraints whose either bound changes
  boundList | the new lower/upper bound pairs for the constraints

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setRowSetTypes | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const char * | senseList,
|  | const double * | rhsList,
|  | const double * | rangeList
| ) |  |
| virtual

Set the type of a number of rows simultaneously
The default implementation just invokes `setRowType()` and over and over again.

Parameters

  <code>[indexfirst,indexLast]</code> | contains the indices of the constraints whose type changes
  senseList | the new senses
  rhsList | the new right hand sides
  rangeList | the new ranges

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setContinuous | ( | int | index | ) |
| virtual

Set the index-th variable to be a continuous variable.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setInteger | ( | int | index | ) |
| virtual

Set the index-th variable to be an integer variable.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setContinuous | ( | const int * | indices,
|  | int | len
| ) |  |
| virtual

Set the variables listed in indices (which is of length len) to be continuous variables.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setInteger | ( | const int * | indices,
|  | int | len
| ) |  |
| virtual

Set the variables listed in indices (which is of length len) to be integer variables.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setObjSense | ( | double | s | ) |
| virtual

Set objective function sense (1 for min (default), -1 for max,)

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setColSolution | ( | const double * | colsol | ) |
| virtual

Set the primal solution column values.

colsol[numcols()] is an array of values of the problem column variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of colsol() until changed by another call to setColsol() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setRowPrice | ( | const double * | rowprice | ) |
| virtual

Set dual solution vector.

rowprice[numrows()] is an array of values of the problem row dual variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of rowprice() until changed by another call to setRowprice() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::addCol | ( | const CoinPackedVectorBase & | vec,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj
| ) |  |
| virtual

Add a column (primal variable) to the problem.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::addCols | ( | const int | numcols,
|  | const CoinPackedVectorBase *const * | cols,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj
| ) |  |
| virtual

Add a set of columns (primal variables) to the problem.

The default implementation simply makes repeated calls to addCol().

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::deleteCols | ( | const int | num,
|  | const int * | colIndices
| ) |  |
| virtual

Remove a set of columns (primal variables) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted variables are nonbasic.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const double | rowlb,
|  | const double | rowub
| ) |  |
| virtual

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const char | rowsen,
|  | const double | rowrhs,
|  | const double | rowrng
| ) |  |
| virtual

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const double * | rowlb,
|  | const double * | rowub
| ) |  |
| virtual

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng
| ) |  |
| virtual

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::deleteRows | ( | const int | num,
|  | const int * | rowIndices
| ) |  |
| virtual

Delete a set of rows (constraints) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted rows are loose.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub
| ) |  |
| virtual

Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `rowub`: all rows have upper bound infinity
- `rowlb`: all rows have lower bound -infinity
- `obj`: all variables have 0 objective coefficient

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | double *& | rowlb,
|  | double *& | rowub
| ) |  |
| virtual

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng
| ) |  |
| virtual

Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `obj`: all variables have 0 objective coefficient
- `rowsen`: all rows are >=
- `rowrhs`: all right hand sides are 0
- `rowrng`: 0 for the ranged rows

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | char *& | rowsen,
|  | double *& | rowrhs,
|  | double *& | rowrng
| ) |  |
| virtual

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub
| ) |  |
| virtual

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng
| ) |  |
| virtual

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual int OsiMskSolverInterface::readMps | ( | const char * | filename,
|  | const char * | extension = `"mps"`
| ) |  |
| virtual

Read an mps file from the given filename.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::writeMps | ( | const char * | filename,
|  | const char * | extension = `"mps"`,
|  | double | objSense = `0.0`
| ) |  | const
| virtual

Write the problem into an mps file of the given filename.

If objSense is non zero then -1.0 forces the code to write a maximization objective and +1.0 to write a minimization one. If 0.0 then solver can do what it wants

Implements OsiSolverInterface.

void OsiMskSolverInterface::passInMessageHandler | ( | CoinMessageHandler * | handler | ) |
| virtual

Pass in a message handler It is the client's responsibility to destroy a message handler installed by this routine; it will not be destroyed when the solver interface is destroyed.

Reimplemented from OsiSolverInterface.

MSKtask_t OsiMskSolverInterface::getLpPtr | ( | int | keepCached = `KEEPCACHED_NONE` | ) |

MSKenv_t OsiMskSolverInterface::getEnvironmentPtr | ( |  | ) |

Method to access MOSEK environment pointer.

const char* OsiMskSolverInterface::getCtype | ( |  | ) | const

return a vector of variable types (continous, binary, integer)

static void OsiMskSolverInterface::incrementInstanceCounter | ( |  | ) |
| static

MOSEK has a context which must be created prior to all other MOSEK calls.

This method:

- Increments by 1 the number of uses of the MOSEK environment.
- Creates the MOSEK context when the number of uses is change to 1 from 0.

static void OsiMskSolverInterface::decrementInstanceCounter | ( |  | ) |
| static

MOSEK has a context which should be deleted after MOSEK calls.

This method:

- Decrements by 1 the number of uses of the MOSEK environment.
- Deletes the MOSEK context when the number of uses is change to 0 from 1.

static unsigned int OsiMskSolverInterface::getNumInstances | ( |  | ) |
| static

Return the number of instances of instantiated objects using MOSEK services.

virtual OsiSolverInterface* OsiMskSolverInterface::clone | ( | bool | copyData = `true` | ) | const
| virtual

Clone.

Implements OsiSolverInterface.

OsiMskSolverInterface& OsiMskSolverInterface::operator= | ( | const OsiMskSolverInterface & | rhs | ) |

Assignment operator.

virtual void OsiMskSolverInterface::applyRowCut | ( | const OsiRowCut & | rc | ) |
| protected virtual

Apply a row cut. Return true if cut was applied.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::applyColCut | ( | const OsiColCut & | cc | ) |
| protected virtual

Apply a column cut (bound adjustment).

Return true if cut was applied.

Implements OsiSolverInterface.

void OsiMskSolverInterface::switchToLP | ( |  | ) |
| private

switches MOSEK to prob type LP

void OsiMskSolverInterface::switchToMIP | ( |  | ) |
| private

switches MOSEK to prob type MIP

void OsiMskSolverInterface::resizeColType | ( | int | minsize | ) |
| private

resizes coltype_ vector to be able to store at least minsize elements

void OsiMskSolverInterface::freeColType | ( |  | ) |
| private

frees colsize_ vector

bool OsiMskSolverInterface::definedSolution | ( | int | solution | ) | const
| private

int OsiMskSolverInterface::solverUsed | ( |  | ) | const
| private

MSKtask_t OsiMskSolverInterface::getMutableLpPtr | ( |  | ) | const

Get task Pointer for const methods.

void OsiMskSolverInterface::gutsOfCopy | ( | const OsiMskSolverInterface & | source | ) |

The real work of a copy constructor (used by copy and assignment)

void OsiMskSolverInterface::gutsOfConstructor | ( |  | ) |

The real work of the constructor.

void OsiMskSolverInterface::gutsOfDestructor | ( |  | ) |

The real work of the destructor.

void OsiMskSolverInterface::freeCachedColRim | ( |  | ) |

free cached column rim vectors

void OsiMskSolverInterface::freeCachedRowRim | ( |  | ) |

free cached row rim vectors

void OsiMskSolverInterface::freeCachedResults | ( |  | ) |

free cached result vectors

void OsiMskSolverInterface::freeCachedMatrix | ( |  | ) |

free cached matrices

void OsiMskSolverInterface::freeCachedData | ( | int | keepCached = `KEEPCACHED_NONE` | ) |

free all cached data (except specified entries, see getLpPtr())

void OsiMskSolverInterface::freeAllMemory | ( |  | ) |

free all allocated memory

## Friends And Related Function Documentation

void OsiMskSolverInterfaceUnitTest | ( | const std::string & | mpsDir,
|  | const std::string & | netlibDir
| ) |  |
| friend

A function that tests the methods in the OsiMskSolverInterface class.

## Member Data Documentation

MSKenv_t OsiMskSolverInterface::env_
| static private

MOSEK environment pointer.

Definition at line 717 of file OsiMskSolverInterface.hpp.

unsigned int OsiMskSolverInterface::numInstances_
| static private

Number of live problem instances.

Definition at line 722 of file OsiMskSolverInterface.hpp.

int OsiMskSolverInterface::Mskerr
| private

Definition at line 727 of file OsiMskSolverInterface.hpp.

int OsiMskSolverInterface::MSKsolverused_
| private

Definition at line 728 of file OsiMskSolverInterface.hpp.

double OsiMskSolverInterface::ObjOffset_
| private

Definition at line 729 of file OsiMskSolverInterface.hpp.

int OsiMskSolverInterface::InitialSolver
| private

Definition at line 731 of file OsiMskSolverInterface.hpp.

MSKtask_t OsiMskSolverInterface::task_
| mutable

MOSEK model represented by this class instance.

Definition at line 766 of file OsiMskSolverInterface.hpp.

int* OsiMskSolverInterface::hotStartCStat_

Hotstart information.

Definition at line 769 of file OsiMskSolverInterface.hpp.

int OsiMskSolverInterface::hotStartCStatSize_

Definition at line 770 of file OsiMskSolverInterface.hpp.

int* OsiMskSolverInterface::hotStartRStat_

Definition at line 771 of file OsiMskSolverInterface.hpp.

int OsiMskSolverInterface::hotStartRStatSize_

Definition at line 772 of file OsiMskSolverInterface.hpp.

int OsiMskSolverInterface::hotStartMaxIteration_

Definition at line 773 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::obj_
| mutable

Pointer to objective vector.

Definition at line 778 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::collower_
| mutable

Pointer to dense vector of variable lower bounds.

Definition at line 781 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::colupper_
| mutable

Pointer to dense vector of variable lower bounds.

Definition at line 784 of file OsiMskSolverInterface.hpp.

char* OsiMskSolverInterface::rowsense_
| mutable

Pointer to dense vector of row sense indicators.

Definition at line 787 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::rhs_
| mutable

Pointer to dense vector of row right-hand side values.

Definition at line 790 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::rowrange_
| mutable

Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows)

Definition at line 793 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::rowlower_
| mutable

Pointer to dense vector of row lower bounds.

Definition at line 796 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::rowupper_
| mutable

Pointer to dense vector of row upper bounds.

Definition at line 799 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::colsol_
| mutable

Pointer to primal solution vector.

Definition at line 802 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::rowsol_
| mutable

Pointer to dual solution vector.

Definition at line 805 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::redcost_
| mutable

Pointer to reduced cost vector.

Definition at line 808 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::rowact_
| mutable

Pointer to row activity (slack) vector.

Definition at line 811 of file OsiMskSolverInterface.hpp.

CoinPackedMatrix* OsiMskSolverInterface::matrixByRow_
| mutable

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 814 of file OsiMskSolverInterface.hpp.

CoinPackedMatrix* OsiMskSolverInterface::matrixByCol_
| mutable

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 817 of file OsiMskSolverInterface.hpp.

char* OsiMskSolverInterface::coltype_

Pointer to dense vector of variable types (continous, binary, integer)

Definition at line 823 of file OsiMskSolverInterface.hpp.

int OsiMskSolverInterface::coltypesize_

Size of allocated memory for coltype_.

Definition at line 826 of file OsiMskSolverInterface.hpp.

bool OsiMskSolverInterface::probtypemip_
| mutable

Stores whether MOSEK' prob type is currently set to MIP.

Definition at line 829 of file OsiMskSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /tmp/Clp-1.17.6/Osi/src/OsiMsk/OsiMskSolverInterface.hpp